﻿local L = AceLibrary("AceLocale-2.2"):new("Cartographer-AlphaScale")

L:RegisterTranslations("enUS", function() return {
	["AlphaScale"] = true,
	
	["Transparency"] = true,
	["Transparency of the World Map"] = true,
	
	["Overlay transparency"] = true,
	["Transparency of World Map overlays"] = true,
	
	["Scale"] = true,
	["Scale of the World Map"] = true,
	
	["Tooltip scale"] = true,
	["Scale of the World Map tooltip"] = true,
	
	["Shift-MouseWheel to change transparency"] = true,
	["Ctrl-MouseWheel to change scale"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["AlphaScale"] = "크기 및 투명도",
	
	["Transparency"] = "투명도",
	["Transparency of the World Map"] = "월드 맵의 투명도를 설정합니다",
	
	["Overlay transparency"] = "오버레이 투명도",
	["Transparency of World Map overlays"] = "월드맵 오버레이의 투명도를 설정합니다.",
	
	["Scale"] = "크기",
	["Scale of the World Map"] = "월드 맵의 크기를 설정합니다",
	
	["Tooltip scale"] = "툴팁 크기",
	["Scale of the World Map tooltip"] = "월드 맵의 툴팁 크기를 설정합니다",
	
	["Shift-MouseWheel to change transparency"] = "Shift-스크롤 : 투명도 변경",
	["Ctrl-MouseWheel to change scale"] = "Ctrl-스크롤 : 크기 변경",
} end)

Cartographer_AlphaScale = Cartographer:NewModule("AlphaScale", "AceEvent-2.0", "AceHook-2.1")

local _G = getfenv(0)
local lua51 = loadstring("return function(...) return ... end") and true or false

local fake_ipairs = lua51 and loadstring([[local tmp = {}; return function(...)
	for k in pairs(tmp) do
		tmp[k] = nil
	end
	for i = 1, select('#', ...) do
		tmp[i] = select(i, ...)
	end
	return ipairs(tmp)
end]])() or loadstring([[local tmp = {}; return function(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,a17,a18,a19,a20)
	for k in pairs(tmp) do
		tmp[k] = nil
	end
	tmp[1] = a1
	tmp[2] = a2
	tmp[3] = a3
	tmp[4] = a4
	tmp[5] = a5
	tmp[6] = a6
	tmp[7] = a7
	tmp[8] = a8
	tmp[9] = a9
	tmp[10] = a10
	tmp[11] = a11
	tmp[12] = a12
	tmp[13] = a13
	tmp[14] = a14
	tmp[15] = a15
	tmp[16] = a16
	tmp[17] = a17
	tmp[18] = a18
	tmp[19] = a19
	tmp[20] = a20
	tmp.n = 20
	while tmp[tmp.n] == nil do
		tmp.n = tmp.n - 1
	end
	return ipairs(tmp)
end]])()

function Cartographer_AlphaScale:OnInitialize()
    self.db = Cartographer:AcquireDBNamespace("AlphaScale")
	Cartographer:RegisterDefaults("AlphaScale", "profile", {
		on = true,
		alpha = 0.8,
		overlayAlpha = 1,
		scale = 0.75,
		ttScale = 1,
	})
	
	Cartographer.options.args.alphaScale = {
		name = L["AlphaScale"],
		desc = L["AlphaScale"],
		type = 'group',
		args = {
			alpha = {
				name = L["Transparency"],
				desc = L["Transparency of the World Map"],
				type = 'range',
				min = 0,
				max = 1,
				step = 0.05,
				isPercent = true,
				get = "GetAlpha",
				set = "SetAlpha",
			},
			overlayAlpha = {
				name = L["Overlay transparency"],
				desc = L["Transparency of World Map overlays"],
				type = 'range',
				min = 0.25,
				max = 1,
				step = 0.05,
				isPercent = true,
				get = "GetOverlayAlpha",
				set = "SetOverlayAlpha",
			},
			scale = {
				name = L["Scale"],
				desc = L["Scale of the World Map"],
				type = 'range',
				min = 0.2,
				max = 1,
				step = 0.05,
				isPercent = true,
				get = "GetScale",
				set = "SetScale",
			},
			ttScale = {
				name = L["Tooltip scale"],
				desc = L["Scale of the World Map tooltip"],
				type = 'range',
				min = 0.2,
				max = 2,
				step = 0.05,
				isPercent = true,
				get = "GetTooltipScale",
				set = "SetTooltipScale",
			},
			toggle = {
				name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Toggle"],
				desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Toggle the module on and off."],
				type = "toggle",
				order = -1,
				get = function() return Cartographer:IsModuleActive(self) end,
				set = function() Cartographer:ToggleModuleActive(self) end
			},
		},
		handler = self,
	}
	
	local orig = WorldMapFrame:GetScript("OnShow") or function() end
	WorldMapFrame:SetScript("OnShow", function()
		orig(this)
		
		if Cartographer:IsModuleActive(self) then
			this:SetScale(self.db.profile.scale)
			WorldMapTooltip:SetScale(self.db.profile.ttScale / self.db.profile.scale)
			this:SetWidth(1024)
			this:SetHeight(768)
		end
	end)
end

local cities = {
	["ThunderBluff"] = true,
	["Ogrimmar"] = true,
	["TheExodar"] = true,
	["Darnassis"] = true,
	["Undercity"] = true,
	["Ironforge"] = true,
	["Stormwind"] = true,
	["SilvermoonCity"] = true,
	["ShattrathCity"] = true,
}

function Cartographer_AlphaScale:OnEnable()
	Cartographer:AddToMagnifyingGlass(L["Shift-MouseWheel to change transparency"])
	Cartographer:AddToMagnifyingGlass(L["Ctrl-MouseWheel to change scale"])
	UIPanelWindows["WorldMapFrame"] = { whileDead=1, area="center", pushable=0 }
	WorldMapFrame:SetFrameStrata("DIALOG")
	WorldMapFrame:EnableMouse(true)
	WorldMapFrame:EnableMouseWheel(true)
	WorldMapFrame:SetMovable(true)
	WorldMapFrame:RegisterForDrag("LeftButton")
	WorldMapFrame:SetScript("OnDragStart", function()
		this:SetWidth(1024)
		this:SetHeight(768)
		this:StartMoving()
	end)
	WorldMapFrame:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()
		
		this:SetWidth(1024)
		this:SetHeight(768)
		local x,y = this:GetCenter()
		local z = UIParent:GetEffectiveScale() / 2 / this:GetScale()
		x = x - GetScreenWidth() * z
		y = y - GetScreenHeight() * z
		self.db.profile.x = x
		self.db.profile.y = y
		this:ClearAllPoints()
		this:SetPoint("CENTER", "UIParent", "CENTER", x, y)
	end)
	WorldMapFrame:SetScript("OnMouseWheel", function()
		local up = (arg1 == 1)
		
		if IsControlKeyDown() then
			local scale = self:GetScale()
			if up then
				scale = scale + 0.1
				if scale > 1 then
					scale = 1
				end
			else
				scale = scale - 0.1
				if scale < 0.2 then
					scale = 0.2
				end
			end
			self:SetScale(scale)
		elseif IsShiftKeyDown() then
			local alpha = self:GetAlpha()
			if up then
				alpha = alpha + 0.1
				if alpha > 1 then
					alpha = 1
				end
			else
				alpha = alpha - 0.1
				if alpha < 0.2 then
					alpha = 0.2
				end
			end
			self:SetAlpha(alpha)
		end
	end)
	WorldMapFrame:SetResizable(true)
	WorldMapFrame:SetAlpha(self.db.profile.alpha)
	WorldMapFrame:SetScale(self.db.profile.scale)
	WorldMapTooltip:SetScale(self.db.profile.ttScale / self.db.profile.scale)
	WorldMapFrame:SetWidth(1024)
	WorldMapFrame:SetHeight(768)
	self.old_WorldMapFrame_OnKeyDown = WorldMapFrame:GetScript("OnKeyDown")
	WorldMapFrame:SetScript("OnKeyDown", nil)
	WorldMapFrame:StartMoving()
	WorldMapFrame:StopMovingOrSizing()
	WorldMapFrame:ClearAllPoints()
	WorldMapFrame:SetPoint("CENTER", UIParent, "CENTER", self.db.profile.x or 0, self.db.profile.y or 0)
	BlackoutWorld:Hide()
	WorldMapTooltip:SetFrameLevel(WorldMapFrame:GetFrameLevel() + 2)
	self:SecureHook(WorldMapDetailFrame, "CreateTexture", "WorldMapDetailFrame_CreateTexture")
	self:SecureHook("SetMapZoom", "WORLD_MAP_UPDATE")
	self:RegisterEvent("WORLD_MAP_UPDATE")
--	self:Hook("ShowWorldMapArrowFrame", true)
	self:SecureHook("WorldMapButton_OnUpdate")
	--if not self.fakePlayerFrame then
	--	self.fakePlayerFrame = CreateFrame
	--end
	if not self.overlayHolder then
		self.overlayHolder = CreateFrame("Frame", "CartographerAlphaScaleOverlayHolder", WorldMapDetailFrame)
		self.overlayHolder:SetPoint("TOPLEFT", WorldMapDetailFrame, "TOPLEFT")
		self.overlayHolder:SetPoint("BOTTOMRIGHT", WorldMapDetailFrame, "BOTTOMRIGHT")
		self.overlayHolder:SetFrameLevel(WorldMapDetailFrame:GetFrameLevel())
	end
	self.overlayHolder:Show()
	
	self.overlayHolder:SetAlpha(self.db.profile.overlayAlpha)
	WorldMapButton:SetAlpha(self.db.profile.overlayAlpha)
	for i,v in fake_ipairs(WorldMapFrame:GetChildren()) do
		if v:GetName() and string.find(v:GetName(), "^Cartographer") then
			v:SetAlpha(self.db.profile.overlayAlpha)
		end
	end
	if not self.playerModel then
		for _,v in fake_ipairs(WorldMapFrame:GetChildren()) do
			if v:GetFrameType() == "Model" and not v:GetName() then
				self.playerModel = v
				break
			end
		end
	end
	self.playerModel:SetAlpha(self.db.profile.overlayAlpha)
	
	if (GetCurrentMapZone() == 0 or cities[GetMapInfo()]) and self.db.profile.overlayAlpha > self.db.profile.alpha then
		WorldMapDetailFrame:SetAlpha(self.db.profile.overlayAlpha)
	else
		WorldMapDetailFrame:SetAlpha(self.db.profile.alpha)
	end
	
	for i = 1, 1000 do
		local texture = _G["WorldMapOverlay" .. i]
		if not texture then
			break
		end
		texture:SetParent(self.overlayHolder)
	end
	if WorldMapFrame:IsShown() then
		ToggleWorldMap()
		ToggleWorldMap()
	end
end

function Cartographer_AlphaScale:OnDisable()
	Cartographer:RemoveFromMagnifyingGlass(L["Shift-MouseWheel to change transparency"])
	Cartographer:RemoveFromMagnifyingGlass(L["Ctrl-MouseWheel to change scale"])
	UIPanelWindows["WorldMapFrame"] = { whileDead=1, area="full", pushable=0 }
	WorldMapFrame:SetFrameStrata("FULLSCREEN")
	WorldMapFrame:EnableMouse(false)
	WorldMapFrame:EnableMouseWheel(false)
	WorldMapFrame:SetScript("OnDragStart", nil)
	WorldMapFrame:SetScript("OnDragStop", nil)
	WorldMapFrame:SetScript("OnMouseWheel", nil)
	WorldMapFrame:StartMoving()
	WorldMapFrame:StopMovingOrSizing()
	WorldMapFrame:SetScale(1)
	WorldMapFrame:SetAlpha(1)
	WorldMapTooltip:SetScale(1)
	WorldMapFrame:StartMoving()
	WorldMapFrame:StopMovingOrSizing()
	WorldMapFrame:ClearAllPoints()
	WorldMapFrame:SetAllPoints(UIParent)
	WorldMapFrame:SetScript("OnKeyDown", self.old_WorldMapFrame_OnKeyDown)
	WorldMapFrame:EnableMouse(false)
	WorldMapFrame:SetMovable(false)
	WorldMapFrame:SetResizable(false)
	self.old_WorldMapFrame_OnKeyDown = nil
	for i = 1, 1000 do
		local texture = _G["WorldMapOverlay" .. i]
		if not texture then
			break
		end
		texture:SetParent(WorldMapDetailFrame)
	end
	self.overlayHolder:Hide()
	BlackoutWorld:Show()
	WorldMapTooltip:SetFrameLevel(WorldMapFrame:GetFrameLevel() + 2)
	if WorldMapFrame:IsShown() then
		ToggleWorldMap()
		ToggleWorldMap()
	end
end

function Cartographer_AlphaScale:ShowWorldMapArrowFrame()
	--return self.hooks.ShowWorldMapArrowFrame(nil)
end

function Cartographer_AlphaScale:WorldMapButton_OnUpdate()
	WorldMapPlayer:SetScale(1)
end

function Cartographer_AlphaScale:WorldMapDetailFrame_CreateTexture(WorldMapDetailFrame, name, layer)
	if name and string.find(name, "^WorldMapOverlay%d+$") then
		local frame = _G[name]
		
		frame:SetParent(self.overlayHolder)
	end
end

function Cartographer_AlphaScale:WORLD_MAP_UPDATE()
	self:SetAlpha(self:GetAlpha())
end

function Cartographer_AlphaScale:GetAlpha()
	return self.db.profile.alpha
end

function Cartographer_AlphaScale:SetAlpha(value)
	self.db.profile.alpha = value
	if Cartographer:IsModuleActive(self) then
		WorldMapFrame:SetAlpha(value)
		if (GetCurrentMapZone() == 0 or cities[GetMapInfo()]) and self.db.profile.overlayAlpha > value then
			WorldMapDetailFrame:SetAlpha(self.db.profile.overlayAlpha)
		else
			WorldMapDetailFrame:SetAlpha(value)
		end
		
		self.overlayHolder:SetAlpha(self.db.profile.overlayAlpha)
		for i,v in fake_ipairs(WorldMapFrame:GetChildren()) do
			if v:GetName() and string.find(v:GetName(), "^Cartographer") then
				v:SetAlpha(self.db.profile.overlayAlpha)
			end
		end
		WorldMapButton:SetAlpha(self.db.profile.overlayAlpha)
		self.playerModel:SetAlpha(self.db.profile.overlayAlpha)
	end
end

function Cartographer_AlphaScale:GetOverlayAlpha()
	return self.db.profile.overlayAlpha
end

function Cartographer_AlphaScale:SetOverlayAlpha(value)
	self.db.profile.overlayAlpha = value
	if Cartographer:IsModuleActive(self) then
		if (GetCurrentMapZone() == 0 or cities[GetMapInfo()]) and value > self.db.profile.alpha then
			WorldMapDetailFrame:SetAlpha(value)
		else
			WorldMapDetailFrame:SetAlpha(self.db.profile.alpha)
		end
		self.overlayHolder:SetAlpha(value)
		for i,v in fake_ipairs(WorldMapFrame:GetChildren()) do
			if v:GetName() and string.find(v:GetName(), "^Cartographer") then
				v:SetAlpha(value)
			end
		end
		WorldMapButton:SetAlpha(value)
		self.playerModel:SetAlpha(value)
	end
end

function Cartographer_AlphaScale:GetScale()
	return self.db.profile.scale
end

function Cartographer_AlphaScale:SetScale(value)
	self.db.profile.scale = value
	
	if Cartographer:IsModuleActive(self) then
		WorldMapFrame:SetScale(value)
		WorldMapTooltip:SetScale(self.db.profile.ttScale / value)
	end
end

function Cartographer_AlphaScale:GetTooltipScale()
	return self.db.profile.ttScale
end

function Cartographer_AlphaScale:SetTooltipScale(value)
	self.db.profile.ttScale = value
	
	if Cartographer:IsModuleActive(self) then
		WorldMapTooltip:SetScale(value / self.db.profile.scale)
	end
end

function Cartographer_AlphaScale:GetRealTooltipScale()
	return self.db.profile.ttScale / self.db.profile.scale
end

function Cartographer_AlphaScale:OnProfileEnable()
	WorldMapFrame:SetPoint("CENTER", "UIParent", "CENTER", self.db.profile.x or 0, self.db.profile.y or 0)
	self:SetScale(self:GetScale())
	self:SetAlpha(self:GetAlpha())
	self:SetTooltipScale(self:GetTooltipScale())
end
