local L = AceLibrary("AceLocale-2.2"):new("Cartographer_InstanceNotes")

Cartographer_InstanceNotes = Cartographer:NewModule("InstanceNotes", "AceConsole-2.0")

function Cartographer_InstanceNotes:OnInitialize()
    Cartographer.options.args.InstanceNotes = {
        name = "InstanceNotes",
        desc = "InstanceNotes",
        type = 'group',
        args = {
            toggle = {
                name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Toggle"],
                desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Toggle the module on and off."],
                type = "toggle",
                order = -1,
                get = function() return Cartographer:IsModuleActive(self) end,
                set = function() Cartographer:ToggleModuleActive(self) end
            },
        },
        handler = self,
    }
end

function Cartographer_InstanceNotes:OnEnable()
    if Cartographer_Notes then
        Cartographer_Notes:RegisterNotesDatabase("InstanceNotes", self.notes)
    end
end

function Cartographer_InstanceNotes:OnDisable()
    if Cartographer_Notes then
        Cartographer_Notes:UnregisterNotesDatabase("InstanceNotes")
    end
end
