﻿local L = AceLibrary("AceLocale-2.2"):new("Cartographer-Notes")

L:RegisterTranslations("enUS", function() return {
	["Notes"] = true,
	
	["White"] = true,
	["Gray"] = true,
	["Red"] = true,
	["Pink"] = true,
	["Yellow"] = true,
	["Orange"] = true,
	["Green"] = true,
	["Lime"] = true,
	["Blue"] = true,
	["Pale blue"] = true,
	["Cyan"] = true,
	["Purple"] = true,
	
	["Unknown"] = true,
	["Custom icon"] = true,
	
	["Create a new note"] = true,
	["New note"] = true,
	["Delete note"] = true,
	["Edit note"] = true,
	["Send note"] = true,
	["Send to party"] = true,
	["Send to raid"] = true,
	["Send to guild"] = true,
	["Send to player"] = true,
	
	["X position"] = true,
	["Y position"] = true,
	["Title"] = true,
	["Info line 1 (optional)"] = true,
	["Info line 2 (optional)"] = true,
	["Creator (optional)"] = true,
	
	["Ctrl-Right-Click on map to add a note"] = true,
	
	["%s from Guild"] = true,
	["%s from Raid"] = true,
	["%s from Party"] = true,
	
	["Error: %s sent you a note with an unknown zone: %q"] = true,
	["Error: %s sent you a note at %q : %.1f, %.1f with the title %q created by %q, but you already have a note at this location."] = true,
	["%s sent you a note at %q : %.1f, %.1f with the title %q created by %q."] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Notes"] = "노트",
	
	["White"] = "흰색",
	["Gray"] = "회색",
	["Red"] = "빨강색",
	["Pink"] = "분홍색",
	["Yellow"] = "노랑색",
	["Orange"] = "주황색",
	["Green"] = "녹색",
	["Lime"] = "라임색",
	["Blue"] = "파랑색",
	["Pale blue"] = "연한 파랑색",
	["Cyan"] = "청색",
	["Purple"] = "심홍색",
	
	["Unknown"] = "알수없음",
	["Custom icon"] = "사용자 아이콘",
	
	["Create a new note"] = "노트 작성",
	["New note"] = "신규 노트",
	["Delete note"] = "노트 삭제",
	["Edit note"] = "노트 편집",
	["Send note"] = "노트 발송",
	["Send to party"] = "파티에 보냄",
	["Send to raid"] = "공격대에 보냄",
	["Send to guild"] = "길드에 보냄",
	["Send to player"] = "플레이어에게 보냄",
    
	["X position"] = "X 위치",
	["Y position"] = "Y 위치",
	["Title"] = "제목",
	["Info line 1 (optional)"] = "정보 라인 1 (선택)",
	["Info line 2 (optional)"] = "정보 라인 2 (선택)",
	["Creator (optional)"] = "신규 (선택)",
	
	["Ctrl-Right-Click on map to add a note"] = "Ctrl-오른쪽-클릭 : 맵 노트 추가",
	
	["%s from Guild"] = "길드로부터 %s 받음",
	["%s from Raid"] = "공격대로부터 %s 받음",
	["%s from Party"] = "파티로부터 %s 받음",
	
	["Error: %s sent you a note with an unknown zone: %q"] = "오류: %s|1이;가; 알려지지 않은 지역 노트를 보냈습니다: %q",
--	["Error: %s sent you a note at %q : %.1f, %.1f with the title %q created by %q, but you already have a note at this location."] = true,
--	["%s sent you a note at %q : %.1f, %.1f with the title %q created by %q."] = true,
} end)

local icons = {}

Cartographer_Notes = Cartographer:NewModule("Notes", "AceHook-2.1", "AceEvent-2.0", "AceComm-2.0", "AceConsole-2.0")
local self = Cartographer_Notes

local Dewdrop = AceLibrary("Dewdrop-2.0")
local BZ = AceLibrary("Babble-Zone-2.2")

local _G = getfenv(0)
local math_mod = math.fmod or math.mod
local lua51 = loadstring("return function(...) return ... end") and true or false
local table_setn = lua51 and function() end or table.setn

local function GetCursorMapLocation(button)
	local x, y = GetCursorPosition()
	local left, top = button:GetLeft(), button:GetTop()
	local width = button:GetWidth()
	local height = button:GetHeight()
	local scale = button:GetEffectiveScale()
	
	return (x/scale - left) / width, (top - y/scale) / height
end

local function getID(x, y)
	return math.floor(x*1000+0.5) + math.floor(y*1000+0.5)*1001
end

local function getrawpoi(zone, id)
	for k,v in pairs(self.externalDBs) do
		if rawget(v, zone) and rawget(v[zone], id) then
			return v[zone][id]
		end
	end
	return rawget(Cartographer_Notes.db.account.pois, zone) and rawget(Cartographer_Notes.db.account.pois[zone], id)
end

function Cartographer_Notes:OnInitialize()
	self:SetCommPrefix("Cartographer-Notes")
	self.externalDBs = {}
	local memoizations = {
		-- icon names
		"Star", "Circle", "Diamond", "Triangle", "Moon", "Square", "Cross", "Skull",
	}
	for zone in BZ:GetIterator() do
		table.insert(memoizations, zone)
	end
	self:RegisterMemoizations(memoizations)
	memoizations = nil
	
	do
		local x = { "Star", "Circle", "Diamond", "Triangle", "Moon", "Square", "Cross", "Skull" }
		
		for i = 1, 8 do
			local t = UnitPopupButtons["RAID_TARGET_" .. i]
			icons[x[i]] = {
				text = t.text,
				r = t.color.r,
				g = t.color.g,
				b = t.color.b,
				path = "Interface\\TargetingFrame\\UI-RaidTargetingIcons",
				cLeft = t.tCoordLeft,
				cRight = t.tCoordRight,
				cTop = t.tCoordTop,
				cBottom = t.tCoordBottom
			}
		end
		
		icons.Unknown = {
			text = L["Unknown"],
			path = "Interface\\Icons\\INV_Misc_QuestionMark",
			hidden = true,
		}
	end
	
	self.db = Cartographer:AcquireDBNamespace("Notes")
	Cartographer:RegisterDefaults("Notes", "account", {
		pois = {
			['*'] = { -- zones
				['*'] = {
					titleR = 1,
					titleG = 1,
					titleB = 1,
					infoR = 1,
					infoG = 1,
					infoB = 1,
					info2R = 1,
					info2G = 1,
					info2B = 1,
					info = "",
					info2 = "",
					creator = "",
					manual = true,
				}
			}
		}
	})
	
	local mt = { __index = function(t, id)
		local zone = t.zone
		for k,v in pairs(self.externalDBs) do
			if v[zone] and v[zone][id] then
				return v[zone][id]
			end
		end
		return self.db.account.pois[zone][id]
	end }
	self.data_prime = setmetatable({}, { __index = function(self, zone)
		self[zone] = setmetatable({zone = zone}, mt)
		return self[zone]
	end } )
	
	self.data = self.db.account.pois
	
	-- vv REMOVE THIS SECTION IN A FEW DAYS (2006-11-12) vv --
	local tmp = {}
	for k,v in pairs(self.db.account.pois) do
		for l in pairs(v) do
			tmp[l] = true
		end
		for l in pairs(tmp) do
			local u = v[l]
			if not u.x then
				v[l] = nil
			else
				if u.x > 1 and u.y > 1 then
					u.x = u.x / 100
					u.y = u.y / 100
				end
				local id = getID(u.x, u.y)
				if l ~= id then
					v[l] = nil
					v[id] = u
				end
			end
		end
		for l in pairs(tmp) do
			tmp[l] = nil
		end
	end
	tmp = nil
	-- ^^ REMOVE THIS SECTION IN A FEW DAYS (2006-11-12) ^^ --
	
	Cartographer.options.args.Notes = {
		name = L["Notes"],
		desc = L["Notes"],
		type = 'group',
		args = {
			toggle = {
				name = AceLibrary("AceLocale-2.2"):new("Cartographer")["Toggle"],
				desc = AceLibrary("AceLocale-2.2"):new("Cartographer")["Toggle the module on and off."],
				type = "toggle",
				order = -1,
				get = function() return Cartographer:IsModuleActive(self) end,
				set = function() Cartographer:ToggleModuleActive(self) end
			},
		},
		handler = self,
	}
end

local oldWorldMapMagnifyingGlassButtonText
function Cartographer_Notes:OnEnable()
	Cartographer:AddToMagnifyingGlass(L["Ctrl-Right-Click on map to add a note"])
	self:Hook("WorldMapButton_OnClick", true)
	self:SecureHook("ToggleWorldMap")
	self:RegisterEvent("WORLD_MAP_UPDATE", "RefreshMap")
	self:RegisterEvent("Cartographer_SetCurrentInstance", "RefreshMap")
	if Cartographer:GetInstanceWorldMapButton() then
		self:HookScript(frame, "OnClick", "InstanceWorldMapButton_OnClick")
	else
		self:RegisterEvent("Cartographer_RegisterInstanceWorldMapButton", function(frame)
			self:HookScript(frame, "OnClick", "InstanceWorldMapButton_OnClick")
		end)
	end
	if WorldMapFrame:IsShown() then
		self:RefreshMap()
	end
	
	local func = function()
		self:WorldMapButton_OnClick(arg1, WorldMapButton)
	end
	WorldMapPlayer:SetScript("OnMouseUp", func)
	for i = 1, 4 do
		_G["WorldMapParty" .. i]:SetScript("OnMouseUp", func)
	end
	for i = 1, 40 do
		_G["WorldMapRaid" .. i]:SetScript("OnMouseUp", func)
	end
	WorldMapFlag1:SetScript("OnMouseUp", func)
	WorldMapFlag2:SetScript("OnMouseUp", func)
	WorldMapCorpse:SetScript("OnMouseUp", func)
	if lua51 then
		WorldMapDeathRelease:SetScript("OnMouseUp", func)
	end
	
	self:RegisterComm(self.commPrefix, "WHISPER")
	self:RegisterComm(self.commPrefix, "GUILD")
	self:RegisterComm(self.commPrefix, "PARTY")
	self:RegisterComm(self.commPrefix, "RAID")
end
function Cartographer_Notes:OnDisable()
	Cartographer:RemoveFromMagnifyingGlass(L["Ctrl-Right-Click on map to add a note"])
	self:ClearMap()
	WorldMapPlayer:SetScript("OnMouseUp", nil)
	for i = 1, 4 do
		_G["WorldMapParty" .. i]:SetScript("OnMouseUp", nil)
	end
	for i = 1, 40 do
		_G["WorldMapRaid" .. i]:SetScript("OnMouseUp", nil)
	end
	WorldMapFlag1:SetScript("OnMouseUp", nil)
	WorldMapFlag2:SetScript("OnMouseUp", nil)
	WorldMapCorpse:SetScript("OnMouseUp", nil)
	if lua51 then
		WorldMapDeathRelease:SetScript("OnMouseUp", nil)
	end
end

Cartographer_Notes.OnCommReceive = {
	SENDNOTE = function(self, prefix, sender, distribution, zone, x, y, title, titleR, titleG, titleB, info, infoR, infoG, infoB, info2, info2R, info2G, info2B, creator, icon, manual)
		if type(zone) ~= "string" or type(x) ~= "number" or type(y) ~= "number" or type(title) ~= "string" or type(titleR) ~= "number" or type(titleG) ~= "number" or type(titleB) ~= "number" or type(info) ~= "string" or type(infoR) ~= "number" or type(infoG) ~= "number" or type(infoB) ~= "number" or type(info2) ~= "string" or type(info2R) ~= "number" or type(info2G) ~= "number" or type(info2B) ~= "number" or type(creator) ~= "string" or type(icon) ~= "string" or type(manual) ~= "boolean" then
			-- bad data
			return
		end
		local fullSender = distribution == "GUILD" and string.format(L["%s from Guild"], sender) or distribution == "RAID" and string.format(L["%s from Raid"], sender) or distribution == "PARTY" and string.format(L["%s from Raid"], sender) or sender
		if not BZ:HasTranslation(zone) then
			self:Print(L["Error: %s sent you a note with an unknown zone: %q"], fullSender, zone)
			return
		end
		x, y = x/1000, y/1000
		local id = getID(x, y)
		local poi = getrawpoi(zone, id)
		if poi and poi.creator ~= creator then
			self:Print(L["Error: %s sent you a note at %q : %.1f, %.1f with the title %q created by %q, but you already have a note at this location."], fullSender, BZ[zone], x*100, y*100, title, creator)
			return
		end
		titleR, titleG, titleB = titleR / 100, titleG / 100, titleB / 100
		infoR, infoG, infoB = infoR / 100, infoG / 100, infoB / 100
		info2R, info2G, info2B = info2R / 100, info2G / 100, info2B / 100
		if self:SetNote(zone, x, y, title, titleR, titleG, titleB, info, infoR, infoG, infoB, info2, info2R, info2G, info2B, creator, icon, manual, id) then
			-- if changed
			self:Print(L["%s sent you a note at %q : %.1f, %.1f with the title %q created by %q."], fullSender, BZ[zone], x*100, y*100, title, creator)
		end
	end
}

function Cartographer_Notes:InstanceWorldMapButton_OnClick(frame, a1)
	if arg1 ~= "RightButton" or not IsControlKeyDown() then
		return self.hooks[frame].OnClick(frame, a1)
	end
	
	if not Cartographer:GetCurrentInstance() then
		return
	end
	
	return self:MapButton_OnClick(arg1, frame)
end

function Cartographer_Notes:WorldMapButton_OnClick(mouseButton, button)
	if mouseButton ~= "RightButton" or not IsControlKeyDown() then
		return self.hooks.WorldMapButton_OnClick(mouseButton, button)
	end
	
	if GetCurrentMapZone() == 0 or GetCurrentMapContinent() < 1 then
		return
	end
	
	if not button then
		button = this
	end
	
	return self:MapButton_OnClick(mouseButton, button)
end

local lastCursorX, lastCursorY
function Cartographer_Notes:MapButton_OnClick(mouseButton, button)
	if not Dewdrop:IsRegistered(WorldMapFrame) then
		local newNoteFunc = function()
			self:OpenNewNoteFrame(lastCursorX, lastCursorY)
			Dewdrop:Close()
		end
		local closeFunc = function()
			Dewdrop:Close()
		end
		Dewdrop:Register(button,
			'children', function()
				Dewdrop:AddLine(
					'text', L["Create a new note"],
					'func', newNoteFunc
				)
				Dewdrop:AddLine()
				Dewdrop:AddLine(
					'text', CANCEL,
					'func', closeFunc
				)
			end,
			'dontHook', true,
			'cursorX', true,
			'cursorY', true
		)
	end
	lastCursorX, lastCursorY = GetCursorMapLocation(button)
	if button == WorldMapFrame then
		Dewdrop:Open(button)
	else
		Dewdrop:Open(button, WorldMapFrame)
	end
end

local mapZones = setmetatable({}, {__index = function(self, key)
	self[key] = { GetMapZones(key) }
	return self[key]
end })

local function GetCurrentLocalizedZoneName()
	local currInstance = Cartographer:GetCurrentInstance()
	if currInstance then
		return BZ[currInstance]
	end
	return mapZones[GetCurrentMapContinent()][GetCurrentMapZone()]
end
function Cartographer_Notes:GetCurrentEnglishZoneName()
	local currInstance = Cartographer:GetCurrentInstance()
	if currInstance then
		return currInstance
	end
	return BZ:GetReverseTranslation(mapZones[GetCurrentMapContinent()][GetCurrentMapZone()])
end

local frame
local function GetNoteDialog()
	if frame then
		return frame
	end
	
	frame = CreateFrame("Frame", "CartographerNotesNewNoteFrame", WorldMapFrame)
	frame:SetPoint("CENTER", WorldMapFrame, "CENTER")
	frame:SetWidth(500)
	frame:SetHeight(330)
	frame:SetFrameLevel(9)
	frame:EnableMouse(true)
	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function()
		this:StartMoving()
	end)
	frame:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()
	end)
	frame:SetBackdrop({
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Border",
		tile = true,
		insets = {
			left = 11,
			right = 12,
			top = 12,
			bottom = 11
		},
		'tileSize', 32,
		'edgeSize', 32
	})
	
	local texture = frame:CreateTexture(nil, "ARTWORK")
	texture:SetTexture("Interface\\DialogFrame\\UI-DialogBox-Header")
	texture:SetWidth(256)
	texture:SetHeight(64)
	texture:SetPoint("TOP", frame, "TOP", 0, 12)
	
	local header = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
	frame.header = header
	header:SetText(L["New note"])
	header:SetPoint("TOP", texture, "TOP", 0, -14)
	
	local okayButton = CreateFrame("Button", "CartographerNotesNewNoteFrameOkay", frame, "UIPanelButtonTemplate2")
	okayButton:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 20, 20)
	okayButton:SetText(OKAY or 'Okay')
	okayButton:SetWidth(frame:GetWidth()/2 - 25)
	
	local cancelButton = CreateFrame("Button", "CartographerNotesNewNoteFrameCancel", frame, "UIPanelButtonTemplate2")
	cancelButton:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -20, 20)
	cancelButton:SetText(CANCEL or 'Cancel')
	cancelButton:SetWidth(frame:GetWidth()/2 - 25)
	cancelButton:SetScript("OnClick", function()
		frame:Hide()
	end)
	
	local last
	local isGood
	
	local OnEscapePressed = function()
		this:ClearFocus()
	end
	
	local OnTextChanged = function()
		if isGood() then
			okayButton:Enable()
		else
			okayButton:Disable()
		end
	end
	
	local function make(text, colorful)
		local editBox = CreateFrame("EditBox", nil, frame)
		editBox:SetFontObject(ChatFontNormal)
		editBox:SetWidth(colorful and 210 or 240)
		editBox:SetHeight(13)
		if not last then
			editBox:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -25, -35)
		else
			editBox:SetPoint("TOPLEFT", last, "BOTTOMLEFT", 0, -20)
		end
		last = editBox
		editBox:SetAutoFocus(false)
		editBox:SetScript("OnEscapePressed", OnEscapePressed)
		editBox:SetScript("OnTextChanged", OnTextChanged)

		local left = editBox:CreateTexture(nil, "BACKGROUND")
		left:SetTexture("Interface\\ChatFrame\\UI-ChatInputBorder-Left")
		left:SetTexCoord(0, 100 / 256, 0, 1)
		left:SetWidth(colorful and 125 or 140)
		left:SetHeight(32)
		left:SetPoint("LEFT", editBox, "LEFT", -10, 0)
		local right = editBox:CreateTexture(nil, "BACKGROUND")
		right:SetTexture("Interface\\ChatFrame\\UI-ChatInputBorder-Right")
		right:SetTexCoord(156/256, 1, 0, 1)
		right:SetWidth(colorful and 125 or 140)
		right:SetHeight(32)
		right:SetPoint("RIGHT", editBox, "RIGHT", 10, 0)
		
		local label = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
		label:SetPoint("RIGHT", editBox, "LEFT", -20, 0)
		label:SetPoint("LEFT", frame, "LEFT", 20, 0)
		label:SetPoint("TOP", editBox, "TOP")
		label:SetPoint("BOTTOM", editBox, "BOTTOM")
		label:SetJustifyH("RIGHT")
		label:SetText(text)
		
		if colorful then
			local button = CreateFrame("Button", nil, editBox)
			button:SetPoint("LEFT", editBox, "RIGHT", 20, 0)
			button:SetWidth(16)
			button:SetHeight(16)
			local texture = button:CreateTexture("ARTWORK")
			texture:SetAllPoints(button)
			texture:SetTexture(1, 1, 1)
			local function changeColor(r, g, b)
				texture:SetTexture(r, g, b)
				editBox:SetTextColor(r, g, b)
				Dewdrop:Close()
			end
			function editBox.resetColor(r, g, b)
				if not r then
					r, g, b = 1, 1, 1
				end
				texture:SetTexture(r, g, b)
				editBox:SetTextColor(r, g, b)
			end
			button:SetScript("OnClick", function()
				Dewdrop:Register(button,
					'children', function()
						Dewdrop:AddLine(
							'text', L["White"],
							'textR', 1,
							'textG', 1,
							'textB', 1,
							'func', changeColor,
							'arg1', 1,
							'arg2', 1,
							'arg3', 1
						)
						Dewdrop:AddLine(
							'text', L["Gray"],
							'textR', 0.8,
							'textG', 0.8,
							'textB', 0.8,
							'func', changeColor,
							'arg1', 0.8,
							'arg2', 0.8,
							'arg3', 0.8
						)
						Dewdrop:AddLine(
							'text', L["Pink"],
							'textR', 1,
							'textG', 0.62,
							'textB', 0.59,
							'func', changeColor,
							'arg1', 1,
							'arg2', 0.62,
							'arg3', 0.59
						)
						Dewdrop:AddLine(
							'text', L["Red"],
							'textR', 1,
							'textG', 0.24,
							'textB', 0.17,
							'func', changeColor,
							'arg1', 1,
							'arg2', 0.24,
							'arg3', 0.17
						)
						Dewdrop:AddLine(
							'text', L["Orange"],
							'textR', 0.98,
							'textG', 0.57,
							'textB', 0,
							'func', changeColor,
							'arg1', 0.98,
							'arg2', 0.57,
							'arg3', 0
						)
						Dewdrop:AddLine(
							'text', L["Yellow"],
							'textR', 1,
							'textG', 0.92,
							'textB', 0,
							'func', changeColor,
							'arg1', 1,
							'arg2', 0.92,
							'arg3', 0
						)
						Dewdrop:AddLine(
							'text', L["Green"],
							'textR', 0,
							'textG', 0.7,
							'textB', 0,
							'func', changeColor,
							'arg1', 0,
							'arg2', 0.7,
							'arg3', 0
						)
						Dewdrop:AddLine(
							'text', L["Lime"],
							'textR', 0.04,
							'textG', 0.95,
							'textB', 0,
							'func', changeColor,
							'arg1', 0.04,
							'arg2', 0.95,
							'arg3', 0
						)
						Dewdrop:AddLine(
							'text', L["Cyan"],
							'textR', 0,
							'textG', 1,
							'textB', 1,
							'func', changeColor,
							'arg1', 0,
							'arg2', 1,
							'arg3', 1
						)
						Dewdrop:AddLine(
							'text', L["Blue"],
							'textR', 0,
							'textG', 0.71,
							'textB', 1,
							'func', changeColor,
							'arg1', 0,
							'arg2', 0.71,
							'arg3', 1
						)
						Dewdrop:AddLine(
							'text', L["Pale blue"],
							'textR', 0.7,
							'textG', 0.82,
							'textB', 0.88,
							'func', changeColor,
							'arg1', 0.7,
							'arg2', 0.82,
							'arg3', 0.88
						)
						Dewdrop:AddLine(
							'text', L["Purple"],
							'textR', 0.83,
							'textG', 0.22,
							'textB', 0.9,
							'func', changeColor,
							'arg1', 0.83,
							'arg2', 0.22,
							'arg3', 0.9
						)
					end,
					'dontHook', true,
					'point', "TOPRIGHT",
					'relativePoint', "BOTTOMRIGHT"
				)
				button:SetScript("OnClick", function()
					if Dewdrop:IsOpen(button) then
						Dewdrop:Close()
					else
						Dewdrop:Open(button)
					end
					PlaySound("igMainMenuOptionCheckBoxOn")
				end)
				button:GetScript("OnClick")()
			end)
		end
		
		return editBox
	end
	
	frame.xEditBox = make(L["X position"])
	frame.yEditBox = make(L["Y position"])
	frame.zone = make(ZONE or "Zone")
	frame.zone:SetScript("OnEditFocusGained", function()
		this:ClearFocus()
	end)
	frame.title = make(L["Title"], true)
	frame.info1 = make(L["Info line 1 (optional)"], true)
	frame.info2 = make(L["Info line 2 (optional)"], true)
	frame.creator = make(L["Creator (optional)"])
	
	frame.xEditBox:SetScript("OnTabPressed", function()
		this:ClearFocus()
		frame.yEditBox:SetFocus()
	end)
	frame.yEditBox:SetScript("OnTabPressed", function()
		this:ClearFocus()
		frame.title:SetFocus()
	end)
	frame.zone:SetScript("OnTabPressed", frame.yEditBox:GetScript("OnTabPressed"))
	frame.title:SetScript("OnTabPressed", function()
		this:ClearFocus()
		frame.info1:SetFocus()
	end)
	frame.info1:SetScript("OnTabPressed", function()
		this:ClearFocus()
		frame.info2:SetFocus()
	end)
	frame.info2:SetScript("OnTabPressed", function()
		this:ClearFocus()
		frame.creator:SetFocus()
	end)
	frame.creator:SetScript("OnTabPressed", function()
		this:ClearFocus()
	end)
	function isGood()
		if frame.title:GetText() == "" then
			return false
		end
		local x = tonumber(frame.xEditBox:GetText())
		if not x then
			return false
		elseif x < 0 or x > 100 then
			return false
		end
		local y = tonumber(frame.yEditBox:GetText())
		if not y then
			return false
		elseif y < 0 or y > 100 then
			return false
		end
		return true
	end
	
	local icon = CreateFrame("Frame", "CartographerNotesNewNoteFrameIcon", frame)
	frame.icon = icon
	icon:SetPoint("TOPLEFT", frame.creator, "BOTTOMLEFT", -20, -10)
	icon:SetWidth(frame:GetWidth()/2 - 25)
	icon:SetHeight(30)
	
	local texture = icon:CreateTexture(nil, "ARTWORK")
	texture:SetTexture("Interface\\Glues\\CharacterCreate\\CharacterCreate-LabelFrame")
	texture:SetWidth(25)
	texture:SetHeight(64)
	texture:SetPoint("TOPLEFT", icon, "TOPLEFT", 0, 17)
	texture:SetTexCoord(0, 0.1953125, 0, 1)
	
	local texture2 = icon:CreateTexture(nil, "ARTWORK")
	texture2:SetTexture("Interface\\Glues\\CharacterCreate\\CharacterCreate-LabelFrame")
	texture2:SetWidth(115)
	texture2:SetHeight(64)
	texture2:SetPoint("LEFT", texture, "RIGHT")
	texture2:SetTexCoord(0.1953125, 0.8046875, 0, 1)
	
	local texture3 = icon:CreateTexture(nil, "ARTWORK")
	texture3:SetTexture("Interface\\Glues\\CharacterCreate\\CharacterCreate-LabelFrame")
	texture3:SetWidth(25)
	texture3:SetHeight(64)
	texture3:SetPoint("LEFT", texture2, "RIGHT")
	texture3:SetTexCoord(0.8046875, 1, 0, 1)
	
	local fontstring = icon:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	fontstring:SetJustifyH("RIGHT")
	fontstring:SetWidth(0)
	fontstring:SetHeight(10)
	fontstring:SetPoint("RIGHT", texture3, "RIGHT", -43, 2)
	
	local image = icon:CreateTexture(nil, "OVERLAY")
	image:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
	image:SetWidth(16)
	image:SetHeight(16)
	image:SetTexCoord(0, 0.25, 0, 0.25)
	image:SetPoint("LEFT", texture, "LEFT", 20, 0)
	
	local button = CreateFrame("Button", "CartographerNotesNewNoteFrameIconButton", icon)
	button:SetWidth(24)
	button:SetHeight(24)
	button:SetPoint("TOPRIGHT", texture3, "TOPRIGHT", -16, -18)
	button:SetNormalTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Up")
	button:SetPushedTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Down")
	button:SetDisabledTexture("Interface\\ChatFrame\\UI-ChatIcon-ScrollDown-Disabled")
	button:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight")
	local iconSelector = function(k)
		icon.value = k
		local t = icons[k]
		if string.find(k, "^Interface\\") then
			fontstring:SetText(L["Custom icon"])
			fontstring:SetTextColor(1, 1, 1)
			image:SetTexture(k)
			if string.find(k, "^Interface\\Icons\\") then
				image:SetTexCoord(0.05, 0.95, 0.05, 0.95)
			else
				image:SetTexCoord(0, 1, 0, 1)
			end
			Dewdrop:Close()
			return
		end
		if not t then
			t = icons.Unknown
		end
		fontstring:SetText(t.text)
		fontstring:SetTextColor(t.r or 1, t.g or 1, t.b or 1)
		image:SetTexture(t.path)
		image:SetTexCoord(t.cLeft or 0, t.cRight or 1, t.cTop or 0, t.cBottom or 1)
		Dewdrop:Close()
	end
	frame.iconSelector = iconSelector
	button:SetScript("OnClick", function()
		local t = {}
		Dewdrop:Register(icon,
			'children', function()
				for k, v in pairs(icons) do
					if not v.hidden then
						table.insert(t, k)
					end
				end
				table.sort(t)
				for _, k in ipairs(t) do
					local v = icons[k]
					Dewdrop:AddLine(
						'text', v.text,
						'textR', v.r or 1,
						'textG', v.g or 1,
						'textB', v.b or 1,
						'icon', v.path,
						'iconCoordLeft', v.cLeft,
						'iconCoordRight', v.cRight,
						'iconCoordTop', v.cTop,
						'iconCoordBottom', v.cBottom,
						'func', iconSelector,
						'arg1', k
					)
				end
				for i = 1, table.getn(t) do
					t[i] = nil
				end
				table_setn(t, 0)
			end,
			'dontHook', true,
			'point', "TOPLEFT",
			'relativePoint', "BOTTOMLEFT"
		)
		button:SetScript("OnClick", function()
			if Dewdrop:IsOpen(icon) then
				Dewdrop:Close()
			else
				Dewdrop:Open(icon)
			end
			PlaySound("igMainMenuOptionCheckBoxOn")
		end)
		button:GetScript("OnClick")()
	end)
	icon:SetScript("OnHide", function()
		if Dewdrop:IsOpen(icon) then
			Dewdrop:Close()
		end
	end)
	
	local function round2(num)
		return math.floor(num*100+0.5)/100
	end
	local function round3(num)
		return math.floor(num*1000+0.5)/1000
	end
	
	okayButton:SetScript("OnClick", function()
		local r,g,b = frame.title:GetTextColor()
		local r2,g2,b2 = frame.info1:GetTextColor()
		local r3,g3,b3 = frame.info2:GetTextColor()
		local x, y = tonumber(frame.xEditBox:GetText())/100, tonumber(frame.yEditBox:GetText())/100
		x,y,r,g,b,r2,g2,b2,r3,g3,b3 = round3(x),round3(y),round2(r),round2(g),round2(b),round2(r2),round2(g2),round2(b2),round2(r3),round2(g3),round2(b3)
		self:SetNote(frame.zonename, x, y, frame.title:GetText(), r,g,b, frame.info1:GetText(), r2, g2, b2, frame.info2:GetText(), r3, g3, b3, frame.creator:GetText(), frame.icon.value, true, frame.id)
		frame:Hide()
	end)
	
	return frame
end

local possibleIcons
function Cartographer_Notes:OpenNewNoteFrame(x, y)
	if not Cartographer:GetCurrentInstance() and (GetCurrentMapZone() == 0 or GetCurrentMapContinent() < 1) then
		return
	end
	
	local frame = GetNoteDialog()
	frame.header:SetText(L["New note"])
	frame.id = nil
	frame.xEditBox:SetText(string.format("%.1f", x*100))
	frame.yEditBox:SetText(string.format("%.1f", y*100))
	frame.zone:SetText(GetCurrentLocalizedZoneName())
	frame.title:SetText("")
	frame.title.resetColor()
	frame.info1:SetText("")
	frame.info1.resetColor()
	frame.info2:SetText("")
	frame.info2.resetColor()
	frame.creator:SetText(UnitName("player"))
	frame:Show()
	frame.title:SetFocus()
	if not possibleIcons then
		possibleIcons = {}
		for k,v in pairs(icons) do
			if not v.hidden then
				table.insert(possibleIcons, k)
			end
		end
	end
	frame.iconSelector(possibleIcons[math.random(1, table.getn(possibleIcons))])
	frame.zonename = Cartographer_Notes:GetCurrentEnglishZoneName()
end

function Cartographer_Notes:ShowEditDialog(zone, id)
	if not Cartographer:GetCurrentInstance() and (GetCurrentMapZone() == 0 or GetCurrentMapContinent() < 1) or not zone or not id or not self.db.account.pois[zone][id].x then
		return
	end
	
	local frame = GetNoteDialog()
	frame.header:SetText(L["Edit note"])
	frame.id = id
	local poi = self.data[zone][id]
	frame.xEditBox:SetText(string.format("%.1f", poi.x*100))
	frame.yEditBox:SetText(string.format("%.1f", poi.y*100))
	frame.zone:SetText(BZ[zone])
	frame.title:SetText(poi.title)
	frame.title.resetColor(poi.titleR, poi.titleG, poi.titleB)
	frame.info1:SetText(poi.info)
	frame.info1.resetColor(poi.infoR, poi.infoG, poi.infoB)
	frame.info2:SetText(poi.info2)
	frame.info2.resetColor(poi.info2R, poi.info2G, poi.info2B)
	frame.creator:SetText(poi.creator)
	frame:Show()
	frame.title:SetFocus()
	frame.iconSelector(poi.icon)
	frame.zonename = zone
end

local pois
do
	local cache = {}
	
	local num_pois = 0
	
	local OnMouseDown, OnMouseUp, OnEnter, OnLeave, OnClick
	
	local dummy
	local function newpoi()
		local x = next(cache)
		if x then
			cache[x] = nil
			x:Show()
			return x
		end
		
		num_pois = num_pois + 1
		
		local frame = CreateFrame("Button", "CartographerNotesPOI" .. num_pois, WorldMapButton)
		
		frame:EnableMouse(true)
		frame:SetMovable(true)
		frame:SetWidth(16)
		frame:SetHeight(16)
		frame:SetPoint("CENTER", WorldMapButton, "CENTER")
		
		local texture = frame:CreateTexture(nil, "OVERLAY")
		frame.texture = texture
		texture:SetAllPoints(frame)
		texture:SetTexture("Interface\\TargetingFrame\\UI-RaidTargetingIcons")
		texture:SetTexCoord(0, 0.25, 0, 0.25)
		
		frame:SetFrameLevel(frame:GetFrameLevel()+3)
		frame:RegisterForClicks("LeftButtonUp", "RightButtonUp")
		if not OnMouseDown then
			OnMouseDown = function()
				if arg1 == "LeftButton" and IsAltKeyDown() then
					if this.manual then
						this.isMoving = true
						this:StartMoving()
					end
				end
			end
		end
		frame:SetScript("OnMouseDown", OnMouseDown)
		
		if not OnMouseUp then
			OnMouseUp = function()
				local this = this
				if arg1 == "LeftButton" then
					if this.isMoving then
						this:StopMovingOrSizing()
						this.isMoving = nil
						local t = self.data[this.zone][this.id]
						local x, y = this:GetCenter()
						local parent = this:GetParent()
						local left, top = parent:GetLeft(), parent:GetTop()
						local width = parent:GetWidth()
						local height = parent:GetHeight()
						x = (x - left) / width
						y = (top - y) / height
						
						t.x, t.y = math.floor(1000*x+0.5)/1000, math.floor(1000*y+0.5)/1000
						if t.x > 1 then
							t.x = 1
						end
						if t.x < 0 then
							t.x = 0
						end
						if t.y > 1 then
							t.y = 1
						end
						if t.y < 0 then
							t.y = 0
						end
						local id = getID(t.x, t.y)
						if id ~= this.id then
							pois[id] = pois[this.id]
							pois[this.id] = nil
							if t == rawget(self.db.account.pois[this.zone], this.id) or not self.externalDBs then
								self.db.account.pois[this.zone][id] = t
								self.db.account.pois[this.zone][this.id] = nil
							else
								for k,v in pairs(self.externalDBs) do
									if rawget(v[this.zone], this.id) == t then
										v[this.zone][id] = t
										v[this.zone][this.id] = nil
										break
									end
								end
							end
						end
						self:ShowNote(this.zone, id)
					end
				end
			end
		end
		frame:SetScript("OnMouseUp", OnMouseUp)
		
		if not OnEnter then
			OnEnter = function()
				local this = this
				local WorldMapTooltip = WorldMapTooltip
				local x, y = this:GetCenter()
				local x2, y2 = WorldMapButton:GetCenter()
				local anchor = ""
				if x > x2 then
					anchor = "ANCHOR_LEFT"
				else
					anchor = "ANCHOR_RIGHT"
				end
				
				WorldMapTooltip:SetOwner(this, anchor)
				WorldMapTooltip:SetText(this.title, this.titleR, this.titleG, this.titleB)
				if this.info then
					WorldMapTooltip:AddLine(this.info, this.infoR, this.infoG, this.infoB)
				end
				if this.info2 then
					WorldMapTooltip:AddLine(this.info2, this.info2R, this.info2G, this.info2B)
				end
				if this.creator then
					WorldMapTooltip:AddDoubleLine("Created by", this.creator)
				end
				WorldMapTooltip:Show()
			end
		end
		frame:SetScript("OnEnter", OnEnter)
		
		if not OnLeave then
			OnLeave = function()
				WorldMapTooltip:Hide()
				GameTooltip:Hide()
			end
		end
		frame:SetScript("OnLeave", OnLeave)
		
		if not OnClick then
			local poi
			OnClick = function()
				if arg1 == "RightButton" then
					if not dummy then
						dummy = CreateFrame("Frame")
						local function editNoteFunc()
							self:ShowEditDialog(poi.zone, poi.id)
							Dewdrop:Close()
						end
						local function deleteNoteFunc()
							self:DeleteNote(poi.zone, poi.id)
							Dewdrop:Close()
						end
						local function closeFunc()
							Dewdrop:Close()
						end
						local function sendNote(distribution, player, poi)
							if player then
								self:SendCommMessage(distribution, player, "SENDNOTE", poi.zone, math.floor(poi.x*1000+0.5), math.floor(poi.y*1000+0.5), poi.title, math.floor(poi.titleR*100+0.5), math.floor(poi.titleG*100+0.5), math.floor(poi.titleB*100+0.5), poi.info, math.floor(poi.infoR*100+0.5), math.floor(poi.infoG*100+0.5), math.floor(poi.infoB*100+0.5), poi.info2, math.floor(poi.info2R*100+0.5), math.floor(poi.info2G*100+0.5), math.floor(poi.info2B*100+0.5), poi.creator, poi.icon, poi.manual)
							else
								self:SendCommMessage(distribution, "SENDNOTE", poi.zone, math.floor(poi.x*1000+0.5), math.floor(poi.y*1000+0.5), poi.title, math.floor(poi.titleR*100+0.5), math.floor(poi.titleG*100+0.5), math.floor(poi.titleB*100+0.5), poi.info, math.floor(poi.infoR*100+0.5), math.floor(poi.infoG*100+0.5), math.floor(poi.infoB*100+0.5), poi.info2, math.floor(poi.info2R*100+0.5), math.floor(poi.info2G*100+0.5), math.floor(poi.info2B*100+0.5), poi.creator, poi.icon, poi.manual)
							end
						end
						local function sendNoteToPartyFunc()
							if not GetNumPartyMembers() > 0 then
								return
							end
							sendNote("PARTY", nil, poi)
						end
						local function sendNoteToRaidFunc()
							if not GetNumRaidMembers() > 0 then
								return
							end
							sendNote("RAID", nil, poi)
						end
						local function sendNoteToGuildFunc()
							if not IsInGuild() then
								return
							end
							sendNote("GUILD", nil, poi)
						end
						local function sendNoteToPlayerFunc(player)
							sendNote("WHISPER", player, poi)
						end
						local function sendNoteToPlayerValidate(player)
							return string.find(player, "^[A-Za-z][A-Za-z]+$")
						end
						Dewdrop:Register(dummy,
							'children', function(level, value)
								if level == 1 then
									if poi.manual then
										Dewdrop:AddLine(
											'text', L["Edit note"],
											'func', editNoteFunc
										)
									end
									Dewdrop:AddLine(
										'text', L["Delete note"],
										'func', deleteNoteFunc
									)
									Dewdrop:AddLine()
									Dewdrop:AddLine(
										'text', L["Send note"],
										'hasArrow', true,
										'value', 'send'
									)
									Dewdrop:AddLine()
									Dewdrop:AddLine(
										'text', CANCEL,
										'func', closeFunc
									)
								elseif level == 2 then
									if value == 'send' then
										local bit = false
										if GetNumPartyMembers() > 0 then
											Dewdrop:AddLine(
												'text', L["Send to party"],
												'func', sendNoteToPartyFunc
											)
											bit = true
										end
										if GetNumRaidMembers() > 0 then
											Dewdrop:AddLine(
												'text', L["Send to raid"],
												'func', sendNoteToRaidFunc
											)
											bit = true
										end
										if IsInGuild() then
											Dewdrop:AddLine(
												'text', L["Send to guild"],
												'func', sendNoteToGuildFunc
											)
											bit = true
										end
										
										if bit then
											Dewdrop:AddLine()
										end
										
										Dewdrop:AddLine(
											'text', L["Send to player"],
											'hasArrow', true,
											'hasEditBox', true,
											'editBoxText', UnitExists("target") and UnitIsPlayer("target") and UnitIsFriendly("target") and UnitName("target") or nil,
											'editBoxFunc', sendNoteToPlayerFunc,
											'editBoxValidateFunc', sendNoteToPlayerValidate
										)
									end
								end
							end,
							'dontHook', true
						)
					end
					poi = this
					Dewdrop:Open(poi, dummy)
				end
			end
		end
		frame:SetScript("OnClick", OnClick)
		
		return frame
	end
	
	local function delpoi(x)
		x:Hide()
		cache[x] = true
		return nil
	end
	
	pois = setmetatable({ del = function(self, id)
		if id == 'del' then
			return
		end
		local x = rawget(self, id)
		rawset(self, id, nil)
		if x then
			delpoi(x)
		end
	end }, { __index = function(self, id)
		local frame = newpoi()
		rawset(self, id, frame)
		return frame
	end })
end

function Cartographer_Notes:SetNote(zone, x, y, title, titleR, titleG, titleB, info, infoR, infoG, infoB, info2, info2R, info2G, info2B, creator, icon, manual, oldId)
	AceLibrary.argCheck(self, zone, 2, "string")
	AceLibrary.argCheck(self, x, 3, "number")
	AceLibrary.argCheck(self, y, 4, "number")
	AceLibrary.argCheck(self, title, 5, "string")
	AceLibrary.argCheck(self, titleR, 6, "number")
	AceLibrary.argCheck(self, titleG, 7, "number")
	AceLibrary.argCheck(self, titleB, 8, "number")
	AceLibrary.argCheck(self, info, 9, "string")
	AceLibrary.argCheck(self, infoR, 10, "number")
	AceLibrary.argCheck(self, infoG, 11, "number")
	AceLibrary.argCheck(self, infoB, 12, "number")
	AceLibrary.argCheck(self, info2, 13, "string")
	AceLibrary.argCheck(self, info2R, 14, "number")
	AceLibrary.argCheck(self, info2G, 15, "number")
	AceLibrary.argCheck(self, info2B, 16, "number")
	AceLibrary.argCheck(self, creator, 16, "string")
	AceLibrary.argCheck(self, icon, 17, "string")
	AceLibrary.argCheck(self, manual, 18, "nil", "boolean")
	AceLibrary.argCheck(self, oldId, 19, "nil", "number")
	if not BZ:HasTranslation(zone) then
		error(string.format("Trying to set a note with an unknown zone: %q", zone), 2)
	end
	if x < 0 or x > 1 then
		error(string.format("Argument #3 is expected to be [0, 1], got %s", x), 2)
	end
	if y < 0 or y > 1 then
		error(string.format("Argument #4 is expected to be [0, 1], got %s", y), 2)
	end
	if title == "" then
		error("Argument #5 must not be an empty string", 2)
	end
	if titleR < 0 or titleR > 1 then
		error(string.format("Argument #6 is expected to be [0, 1], got %s", titleR), 2)
	end
	if titleG < 0 or titleG > 1 then
		error(string.format("Argument #7 is expected to be [0, 1], got %s", titleG), 2)
	end
	if titleB < 0 or titleB > 1 then
		error(string.format("Argument #8 is expected to be [0, 1], got %s", titleB), 2)
	end
	if infoR < 0 or infoR > 1 then
		error(string.format("Argument #10 is expected to be [0, 1], got %s", infoR), 2)
	end
	if infoG < 0 or infoG > 1 then
		error(string.format("Argument #11 is expected to be [0, 1], got %s", infoG), 2)
	end
	if infoB < 0 or infoB > 1 then
		error(string.format("Argument #12 is expected to be [0, 1], got %s", infoB), 2)
	end
	if info2R < 0 or info2R > 1 then
		error(string.format("Argument #14 is expected to be [0, 1], got %s", info2R), 2)
	end
	if info2G < 0 or info2G > 1 then
		error(string.format("Argument #15 is expected to be [0, 1], got %s", info2G), 2)
	end
	if info2B < 0 or info2B > 1 then
		error(string.format("Argument #16 is expected to be [0, 1], got %s", info2B), 2)
	end
	if icon == "" then
		error("Argument #17 must not be an empty string", 2)
	end
	if manual == nil then
		manual = false
	end
	
	local usingDB = self.externalDBs[creator] and not manual and creator or nil
	
	local poi
	local id = getID(x, y)
	if oldId and id ~= oldId then
		if not usingDB then
			if rawget(self.db.account.pois[zone], oldId) then
				self.db.account.pois[zone][id] = self.db.account.pois[zone][oldId]
				self.db.account.pois[zone][oldId] = nil
			end
		else
			if rawget(self.externalDBs[creator], zone) and rawget(self.externalDBs[creator][zone], oldId) then
				self.externalDBs[creator][zone][id] = self.externalDBs[creator][zone][oldId]
				self.externalDBs[creator][zone][oldId] = nil
			end
		end
		if zone == Cartographer_Notes:GetCurrentEnglishZoneName() then
			pois[id] = pois[oldId]
			pois[oldId] = nil
		end
	end
	if not usingDB then
		poi = self.db.account.pois[zone][id]
	else
		if not self.externalDBs[creator][zone] then
			self.externalDBs[creator][zone] = {}
		end
		if not self.externalDBs[creator][zone][id] then
			self.externalDBs[creator][zone][id] = {}
		end
		poi = self.externalDBs[creator][zone][id]
	end
	local different = poi.x ~= x or poi.y ~= y or poi.title ~= title or poi.info ~= info or poi.info2 ~= info2 or poi.creator ~= creator or poi.icon ~= icon or poi.titleR ~= titleR or poi.titleG ~= titleG or poi.titleB ~= titleB or poi.infoR ~= infoR or poi.infoG ~= infoG or poi.infoB ~= infoB or poi.info2R ~= info2R or poi.info2G ~= info2G or poi.info2B ~= info2B or poi.manual ~= manual
	poi.x = x
	poi.y = y
	poi.title = title
	poi.titleR = titleR
	poi.titleG = titleG
	poi.titleB = titleB
	poi.info = info
	poi.infoR = infoR
	poi.infoG = infoG
	poi.infoB = infoB
	poi.info2 = info2
	poi.info2R = info2R
	poi.info2G = info2G
	poi.info2B = info2B
	poi.creator = creator
	poi.icon = icon
	poi.manual = manual
	if zone ~= Cartographer_Notes:GetCurrentEnglishZoneName() then
		return
	end
	self:ShowNote(zone, id)
	return different
end

function Cartographer_Notes:GetNote(zone, x, y)
	AceLibrary.argCheck(self, zone, 2, "string")
	AceLibrary.argCheck(self, x, 3, "number")
	AceLibrary.argCheck(self, y, 4, "number")
	if not BZ:HasTranslation(zone) then
		error(string.format("Trying to get a note with an unknown zone: %q", zone), 2)
	end
	if x < 0 or x > 1 then
		error(string.format("Argument #3 is expected to be [0, 1], got %s", x), 2)
	end
	if y < 0 or y > 1 then
		error(string.format("Argument #4 is expected to be [0, 1], got %s", y), 2)
	end
	local id = getID(x, y)
	local t = getrawpoi(zone, id)
	if not t then
		return nil
	end
	
	return t.title, t.titleR, t.titleG, t.titleB, t.info, t.infoR, t.infoG, t.infoB, t.info2, t.info2R, t.info2G, t.info2B, t.creator, t.icon, t.manual
end

function Cartographer_Notes:DeleteNote(zone, x, y)
	AceLibrary.argCheck(self, zone, 2, "string")
	AceLibrary.argCheck(self, x, 3, "number")
	AceLibrary.argCheck(self, y, 4, "nil", "number")
	if not BZ:HasTranslation(zone) then
		error(string.format("Trying to destroy a note with an unknown zone: %q", zone), 2)
	end
	if y then
		if x < 0 or x > 1 then
			error(string.format("Argument #3 is expected to be [0, 1], got %s", x), 2)
		end
		if y < 0 or y > 1 then
			error(string.format("Argument #4 is expected to be [0, 1], got %s", y), 2)
		end
	end
	local id
	if not y then
		id = x
	else
		id = getID(x, y)
	end
	local t = getrawpoi(zone, id)
	if not t then
		error(string.format("Cannot destroy note %q at %q if it does not exist", id, zone), 2)
	end
	if t ~= rawget(self.db.account.pois[zone], id) then
		for k,v in pairs(self.externalDBs) do
			if rawget(v, zone) and rawget(v[zone], id) == t then
				v[zone][id] = nil
				break
			end
		end
	else
		self.db.account.pois[zone][id] = nil
	end
	if zone == Cartographer_Notes:GetCurrentEnglishZoneName() then
		pois:del(id)
	end
end

function Cartographer_Notes:ShowNote(zone, id)
	if zone ~= Cartographer_Notes:GetCurrentEnglishZoneName() or not Cartographer:IsActive(self) then
		return
	end
	local poi = pois[id]
	local data = self.data[zone][id]
	poi.x = data.x
	poi.y = data.y
	poi.zone = zone
	poi.title = data.title
	poi.titleR = data.titleR
	poi.titleG = data.titleG
	poi.titleB = data.titleB
	poi.info = data.info
	poi.infoR = data.infoR
	poi.infoG = data.infoG
	poi.infoB = data.infoB
	poi.info2 = data.info2
	poi.info2R = data.info2R
	poi.info2G = data.info2G
	poi.info2B = data.info2B
	poi.creator = data.creator
	poi.icon = data.icon
	poi.manual = data.manual
	poi.id = id
	
	local button = zone == Cartographer:GetCurrentInstance() and Cartographer:GetInstanceWorldMapButton() or WorldMapButton
	
	poi:SetParent(button)
	if string.find(data.icon, "^Interface\\") then
		poi.texture:SetTexture(data.icon)
		if string.find(data.icon, "^Interface\\Icons\\") then
			poi.texture:SetTexCoord(0.05, 0.95, 0.05, 0.95)
		else
			poi.texture:SetTexCoord(0, 1, 0, 1)
		end
	else
		local t = icons[data.icon]
		if not t then
			t = icons.Unknown
		end
		poi.texture:SetTexture(t.path)
		poi.texture:SetTexCoord(t.cLeft or 0, t.cRight or 1, t.cTop or 0, t.cBottom or 1)
	end
	poi:Show()
	
	poi:ClearAllPoints()
	poi:SetPoint("CENTER", button, "TOPLEFT", data.x * button:GetWidth(), -data.y * button:GetHeight())
end

local lastMap = nil
function Cartographer_Notes:ClearMap()
	for k,v in pairs(pois) do
		pois:del(k)
	end
	lastMap = nil
end

function Cartographer_Notes:RefreshMap()
	if not Cartographer:GetCurrentInstance() and (GetCurrentMapZone() == 0 or GetCurrentMapContinent() < 1) then
		self:ClearMap()
		return
	end
	local zone = Cartographer_Notes:GetCurrentEnglishZoneName()
	if zone == lastMap then
		return
	end
	self:ClearMap()
	if rawget(self.db.account.pois, zone) then
		for id in pairs(self.db.account.pois[zone]) do
			self:ShowNote(zone, id)
		end
	end
	for k,v in pairs(self.externalDBs) do
		if rawget(v, zone) then
			for id in pairs(v[zone]) do
				self:ShowNote(zone, id)
			end
		end
	end
	lastMap = zone
end

function Cartographer_Notes:ToggleWorldMap()
	if CartographerNotesNewNoteFrame then
		CartographerNotesNewNoteFrame:Hide()
	end
	if not WorldMapFrame:IsShown() then
		self:ClearMap()
	end
end

function Cartographer_Notes:RegisterNotesDatabase(name, db)
	AceLibrary.argCheck(self, name, 2, "string")
	AceLibrary.argCheck(self, db, 3, "table")
	if self.externalDBs[name] then
		error("Cannot register a database already registered.", 2)
	end
	self.externalDBs[name] = db
	self.data = self.data_prime
	
        if WorldMapFrame:IsVisible() then
                local zone = Cartographer_Notes:GetCurrentEnglishZoneName()
                if rawget(db, zone) then
                        for id in pairs(db[zone]) do
                                self:ShowNote(zone, id)
                        end
                end
        end
end

function Cartographer_Notes:UnregisterNotesDatabase(name)
	AceLibrary.argCheck(self, name, 2, "string")
	if not self.externalDBs[name] then
		error("Cannot unregister a database not registered.", 2)
	end
	local t = self.externalDBs[name]
	self.externalDBs[name] = nil
	if not next(self.externalDBs) then
		for k,v in pairs(self.data_prime) do
			self.data_prime[k] = nil
		end
		self.data = self.db.account.pois
	end
	local zone = Cartographer_Notes:GetCurrentEnglishZoneName()
	if rawget(t, zone) then
		for id in pairs(t[zone]) do
			pois:del(id)
		end
	end
end
